#define WIDTH      240
#define HEIGHT     100
#define SIZE       ((HEIGHT+2)*(WIDTH+2))
#define IX(i,j)    ((i)+(WIDTH+2)*(j))
#define SWAP(x0,x) {float *tmp=x0;x0=x;x=tmp;}

void add_source(float *x, float *s, float dt);

void model_set_bnd_rout(void *func);

void diffuse_bad(int b, float *x, float *x0, float diff, float dt);

void diffuse(int b, float *x, float *x0, float diff, float dt);

void diffuse_fixed(int b, float *x, float *x0, float diff, float dt);

void advect(int b, float *d, float *d0, float *u, float *v, float dt);

void dens_step(float *x, float *x0, float *u, float *v, float diff, float dt);

void project(float *u, float *v, float *p, float *div);

void vel_step(float *u, float *v, float *u0, float *v0, float visc, float dt);


